<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 04/06/14
 * Time: 14:06
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Logic;
require_once 'Zend/Mail.php';
require_once 'Zend/View.php';
require_once 'Zend/Mail/Transport/Smtp.php';

class Mail extends \Zend_Mail{

    private $transport;
    private $template;

    public function setTemplate($template)
    {
        $this->template = $template;
    }

    public function getTemplate()
    {
        return $this->template;
    }

    public function __construct($nrorg=1, $charset=null){

        parent::__construct($charset);

        $this->getConfig($nrorg);

    }

    protected function getConfig($nrorg){
        $db=\Setforms2\Runtime\Connection::getInstance();

        $queryParams['P_NRORG']=$nrorg;
        $smtpParams=$db->fetchAll("SELECT DSEMAILFROM, DSSMTPPASS, DSSMTPLOGIN, NRSMTPPORT, DSSMTPSERVER,
                                   IDPROTOCOLCRIPT FROM PARAMGERAL WHERE NRORG=:P_NRORG",$queryParams);
/// DSEMAILFROM DSSMTPPATH DSSMTPLOGIN NRSMTPPORT DSSMTPSERVER
        $options = array(
            'username' => $smtpParams[0]['DSSMTPLOGIN'],
            'password' => $smtpParams[0]['DSSMTPPASS'],
            'port'     => $smtpParams[0]['NRSMTPPORT'],
        );


        $options['auth'] = 'login';
        $protocol = $smtpParams[0]['IDPROTOCOLCRIPT'];
        if ($protocol!=="clr"){
            $options['ssl'] = $smtpParams[0]['IDPROTOCOLCRIPT'];
        }

        $this->transport = new \Zend_Mail_Transport_Smtp($smtpParams[0]["DSSMTPSERVER"], $options);
        self::setDefaultFrom($smtpParams[0]["DSEMAILFROM"]);
    }

    public function sendMail(){

        return $this->send($this->transport);

    }

    public function downloadAttach($url, $filename=null){
        set_time_limit(0);
        if ($filename===null) $filename="file";
        $db = \Setforms2\Runtime\Connection::getInstance();
        $proxyparams=$db->fetchAll('SELECT DSIPPROXY, DSPROXYUSER, DSPROXYPASS, IDUTIPROXY FROM PARAMGERAL');
        $proxyparams=$proxyparams[0];
        $file = sys_get_temp_dir()."/$filename";
        $fp = fopen ($file, 'w+');
        $ch = curl_init($url);
        curl_setopt_array($ch, array(
            CURLOPT_URL            => $url,
            CURLOPT_BINARYTRANSFER => 1,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FILE           => $fp,
            CURLOPT_TIMEOUT        => 600,
            CURLOPT_USERAGENT      => 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
            CURLOPT_PROXYPORT      => 8080,
            CURLOPT_PROXYTYPE      => 'HTTP'
        ));

        if ($proxyparams[0]["IDUTIPROXY"] === 'S'){
            curl_setopt_array($ch, array(

                CURLOPT_PROXY          => $proxyparams['DSIPPROXY'],
                CURLOPT_PROXYUSERPWD   => $proxyparams['DSPROXYUSER'].':'.$proxyparams['DSPROXYPASS'],

            ));
        }
        if(curl_exec($ch) === false){
            echo 'Curl error: ' . curl_error($ch);
        }
        curl_close($ch);
        $fileName = basename($file);
        $mimeType = mime_content_type($file);
        $content = file_get_contents($file);
        $at = new \Zend_Mime_Part($content);
        $at->type = $mimeType;
        $at->disposition = \Zend_Mime::DISPOSITION_ATTACHMENT;
        $at->encoding    = \Zend_Mime::ENCODING_BASE64;
        $at->filename    = $fileName;
        $this->addAttachment($at);
        fclose($fp);
    }

    public function attachFile($file){

        $fileName = basename($file);
        $mimeType = mime_content_type($file);
        $content = file_get_contents($file);

        $at = new \Zend_Mime_Part($content);
        $at->type = $mimeType;
//            if($attachmentInline) {
//                $at->disposition = \Zend_Mime::DISPOSITION_INLINE;
//            } else {
        $at->disposition = \Zend_Mime::DISPOSITION_ATTACHMENT;
//            }
        $at->encoding    = \Zend_Mime::ENCODING_BASE64;
        $at->filename    = $fileName;

        $this->addAttachment($at);
    }

    public function buildTemplate($body,$logo=null){
        $view=new \Zend_View();
        $logoTag="<img border='0' src='$logo'/>";
        $view->setScriptPath(__DIR__."/templates");
        $formattedBody=nl2br(htmlentities($body,null,"UTF-8"));
        $view->assign('content', $formattedBody);
//        $view->assign('content', $body);
        $view->assign('logo', $logoTag);
        $html=$view->render($this->template);
        $this->setBodyHtml($html);
    }

    public function setBody($body){
        $formattedBody=nl2br(htmlentities($body,null,"UTF-8"));
        $this->setBodyHTML($formattedBody);
    }

    public function setUnformattedSubject($subject){
        $formattedSubject=htmlentities($subject,null,"UTF-8");
        $this->setSubject($formattedSubject);
    }


}


