/* Tabela FRMTCOLLAY: TABELA DE FORMATAO DE COLUNA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela FRMTCOLLAY */
/* Objetivo: Gerar um log que vai registrar as alteraes na FRMTCOLLAY,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_FRMTCOLLAY
AFTER DELETE OR INSERT OR UPDATE
ON FRMTCOLLAY FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
  IF UPDATING THEN
    IF NVL(:NEW.CDFRMTCOLLAY,'NULL') <> NVL(:OLD.CDFRMTCOLLAY,'NULL') THEN
        V_DESC := 'Cd do Formato da Coluna ' || '' || NVL(:NEW.CDFRMTCOLLAY,'');
    END IF;
    IF NVL(:NEW.DSFRMTCOLLAY,'NULL') <> NVL(:OLD.DSFRMTCOLLAY,'NULL') THEN
       V_DESC := NVL(V_DESC,'') || ' ' || 'Formato do Campo no Layout ' || '' || NVL(:NEW.DSFRMTCOLLAY,'');
    END IF;
      V_ITPESQ := :NEW.CDFRMTCOLLAY;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cd do Formato da Coluna  '   || '' || NVL(:NEW.CDFRMTCOLLAY,'' )   || ' ' ||
                  'Formato do Campo no Layout ' || '' || NVL(:NEW.DSFRMTCOLLAY,'' );
      V_ITPESQ := :NEW.CDFRMTCOLLAY;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd do Formato da Coluna  '   || '' || NVL(:OLD.CDFRMTCOLLAY,'' )   || ' ' ||
                  'Formato do Campo no Layout ' || '' || NVL(:OLD.DSFRMTCOLLAY,'' );
      V_ITPESQ := :OLD.CDFRMTCOLLAY;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('FRMTCOLLAY',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_FRMTCOLLAY','5.20.001'); END;
/
