/* Sistemas Integrados TEKNISA

Nome: DTULTATU_PARAMBLOQNFAFIL

@C:\Web_506\Sql\End_Conv\Oracle\03AB_GERTRGS_DTULTATU_PARAMBLOQNFAFIL.sql

Descrio:
Rotina para atualizao de cache da tabela PARAMBLOQNFAFIL

Criao:
29/09/2009 - Fileas Job
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PARAMBLOQNFAFIL'  and
            type = 'TR'                          and
            u.uid = o.uid                        and
            u.name = USER)
   DROP TRIGGER DTULTATU_PARAMBLOQNFAFIL
GO

CREATE TRIGGER DTULTATU_PARAMBLOQNFAFIL
ON PARAMBLOQNFAFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			(SELECT 'PARAMBLOQNFAFIL', NULL, 'CDFILIAL=' + CDFILIAL +
                                          ';IDENTRSAIDOP=' + IDENTRSAIDOP +
                                          ';CDTIPOOPER=' + CDTIPOOPER +
                                          ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARAMBLOQNFAFIL
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PARAMBLOQNFAFIL.CDFILIAL, 0)     = ISNULL(INSERTED.CDFILIAL, 0))     AND
            (ISNULL(PARAMBLOQNFAFIL.IDENTRSAIDOP, 0) = ISNULL(INSERTED.IDENTRSAIDOP, 0)) AND
            (ISNULL(PARAMBLOQNFAFIL.CDTIPOOPER, 0)   = ISNULL(INSERTED.CDTIPOOPER, 0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PARAMBLOQNFAFIL','5.06.032';
GO
